﻿Public Class frmMain

    Private xmlFormatter As New Messaging.XmlMessageFormatter(New Type() {GetType([String])})
    Private strSendQueue As String = ".\Private$\app2_queue"
    Private strRecvQueue As String = ".\Private$\app1_queue"

    ''' <summary>
    ''' フォームロード時の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '送信用メッセージキューの存在を確認し、ない場合は作成する
        If Messaging.MessageQueue.Exists(strSendQueue) = False Then
            Messaging.MessageQueue.Create(strSendQueue)
        End If

        '受信用メッセージキューの存在を確認し、ない場合は作成する
        If Messaging.MessageQueue.Exists(strRecvQueue) = False Then
            Messaging.MessageQueue.Create(strRecvQueue)
        End If

        'パスを設定
        MessageQueue1.Path = strSendQueue
        MessageQueue2.Path = strRecvQueue

        '受信開始
        MessageQueue2.BeginReceive()
    End Sub

    ''' <summary>
    ''' [送信]ボタンクリック時の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSend.Click
        MessageQueue1.Send(New Messaging.Message(txtSendMsg.Text, xmlFormatter))
    End Sub

    ''' <summary>
    ''' メッセージ受信時の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub MessageQueue2_ReceiveCompleted(ByVal sender As System.Object, ByVal e As System.Messaging.ReceiveCompletedEventArgs) Handles MessageQueue2.ReceiveCompleted
        Dim msg As Messaging.MessageQueue = CType(sender, Messaging.MessageQueue)
        msg.Formatter = xmlFormatter
        '受信メッセージの表示
        txtReceiveMsg.Text = msg.EndReceive(e.AsyncResult).Body.ToString()

        '受信再開
        Me.MessageQueue2.BeginReceive()
    End Sub
End Class
